
/*
#ifdef _ctypeinfo_exe_
#define WIN32_LEAN_AND_MEAN
#include "objbase.inc"
#include "shlobj.inc"
#include "stdio.inc"
//#include "stringify.inc"
#use "C:\\Totalcmd\\bin\\library\\typelib.obj"

declare extern stringifyCustomType(HREFTYPE refType, ITypeInfo* pti),string *; // heap !
declare extern stringifyTypeDesc(TYPEDESC* typeDesc, ITypeInfo* pTypeInfo),string *; // heap !
declare extern stringifyVarDesc(VARDESC* varDesc, ITypeInfo* pti),string *; // heap !
declare extern __w2s alias w2s(wstring *wsz),string *; // heap !
extern int _astrcpy(string *dst,string *src);
extern int _astrlen(string *str);
extern int _astrcat(string *dst,string *src);

extern STRINGIFY_NO_CPP as int;         // convert all SDK types to aurora types
extern STRINGIFY_CONVERTENUMS as int;   // convert enum names to int.           STRINGIFY_NO_CPP must be set.
extern STRINGIFY_CONVERTSTRUCTS as int; // convert structure names to pointers. STRINGIFY_NO_CPP must be set.
extern STRINGIFY_CONVERTALIASES as int; // convert aliases to int/pointer.      STRINGIFY_NO_CPP must be set.
*/
declare extern __s2w alias s2w(wstring *wsz),string *; // heap !
declare cdecl extern __strappend alias _strappend(string *str1,string *str2),string *; // heap !
declare extern __stringifyTypeDesc alias stringifyTypeDesc(TYPEDESC* typeDesc, ITypeInfo* pTypeInfo),string *; // heap !


/*
sub #CSafePointer
*/
class CSafePointer
{
	declare CSafePointer();

	// call SetSafeMode(TRUE) to turn safe mode ON: returned pointers are set to empty string instead NULL
	declare SetSafeMode(BOOL safe);

	// if pstr is NULL and safe mode is set, the return value is pointer to empty string. Otherwise it is pstr
	declare GetSafePointer(string *pstr),string *;

	// returns the first nonzero pointer using safe mode
	declare ChooseValidPointer(string *str1,string *str2),string *;
	declare SafeFreeHeap(void *ppVariable);
	declare SafeRelease(IUnknown *ppUnk);
	BOOL m_isSafe;
}




/*
sub #CFuncDesc
*/
class CFuncDesc : CSafePointer
{
	declare  CFuncDesc();
	declare _CFuncDesc();
	declare Free();
	declare Init();
	// GetName returns method name. If withprefix is TRUE, default prefixes are: "get_", "put_" and "putref_"
	// any of prefixes can be replaced by passing the prefix: string* = GetName(TRUE, "get", NULL, "Putref")
	declare GetName(opt BOOL withprefix=FALSE,opt string* get_=0,opt string* put_=0,opt string* putref_=0),string *; // [m_nameprefixed]
	declare GetParamsCount(),int;
	declare GetParamName(int index),string *;        // *** "HostName"      [m_names[]]
	declare GetParamType(int index),string *;        // *** "BSTR"          [m_paramtype]
	declare GetParamTypeEx(int index),TYPEDESC *;
	declare GetParamTypeAndName(int index),string *; // *** "BSTR HostName" [m_paramtypename]

	// return value
	declare HasReturnValue(),BOOL;
	declare GetRetvalType(),string *; // ***

	ITypeInfo *m_pti;
	FUNCDESC  *m_funcdesc;  // current function
	LPSTR     *m_names;     // current function and parameter names. m_names[0] is the method name, m_names[1-*] - param names
	int        m_namescount;
	// heap strings
	string    *m_paramtype;     // "BSTR"
	string    *m_retvaltype;    // "HRESULT"
	string    *m_nameprefixed;  // "get_HostName"
	string    *m_paramtypename; // "HWND "
}
#define CFuncDesc_argsize 8<<2


/*
sub #CVarDesc
*/
class CVarDesc : CSafePointer
{
	declare  CVarDesc();
	declare _CVarDesc();
	declare Free();
	declare GetName(),string*;
	declare GetType(),string*;
//	declare AttachVarDesc(VARDESC *pvardesc),BOOL;

	ITypeInfo *m_pti;
	VARDESC   *m_vardesc;
	// heap strings
	string    *m_pName;
	string    *m_pType;
}
#define CVarDesc_argsize 4<<2


/*
sub #CTypeInfo
*/
class CTypeInfo : CSafePointer
{
	declare  CTypeInfo();
	declare _CTypeInfo();
	declare Free();
	declare AttachTypeInfo(ITypeInfo *pti),BOOL;
	declare Attach(CTypeInfo info),BOOL;

	// GetDocumentation wrppers
	declare GetName(opt MEMBERID memid=-1),string*;
	declare GetDocString(opt MEMBERID memid=-1),string*;
	declare GetHelpFile(opt MEMBERID memid=-1),string*;
	declare GetHelpContext(opt MEMBERID memid=-1),int;

	// interfaces
	declare GetDerieved(CTypeInfo info,opt int index=0),BOOL; // info can be equal this
	// methods
	declare GetFuncCount(),int;
	declare GetFuncDesc(int index,CFuncDesc func),BOOL;
	// properties
	declare GetVarCount(),int;
	declare GetVarDesc(int index,CVarDesc var),BOOL; // todo
	// unknown types
	declare FindDefinition(string *name),BOOL; // set m_tlb,m_stdole. 'm_finder' is valid if found
//todo
	declare GetStructDef(string *StructName),string*;
//todo
	declare GetEnumDef(string *EnumName),string*;

	ITypeInfo *m_pti;    // Attach, AttachTypeInfo
	TYPEATTR  *m_ptattr; // Attach, AttachTypeInfo
	ITypeLib  *m_tlb;    // m_pti->GetContainingTypeLib
	ITypeLib  *m_stdole; // LoadTypeLib(L"stdole2.tlb", &m_stdole);
	ITypeInfo *m_finder; // set in FindDefinition
	
	string   *m_pName;
	string   *m_pDocString;
	string   *m_pHelpFile;
	int       m_HelpContext;
}
#define CTypeInfo_argsize 9<<2

/*
sub #CTypeLib
*/
class CTypeLib : CSafePointer // not creatable yet
{
	declare  CTypeLib();
	declare _CTypeLib();
	declare Free();
	declare Load(string *filename),BOOL;
	declare GetCount(),int;
	declare GetTypeInfo(CTypeInfo info,int index),BOOL;
	declare GetTypeInfoOfGuid(CTypeInfo info,GUID *guid),BOOL; // not tested
	declare GetKindCount(TYPEKIND tkind),int;
	declare GetKindIndex(TYPEKIND tkind,int index),int; // returns the index of index-th kind. See GetInterface
	// typed
	declare GetEnumCount(),int;
//	declare GetEnum(,int index),BOOL;
	declare GetStructCount(),int;
//	declare GetStruct(,int index),BOOL;
	declare GetModuleCount(),int;
//	declare GetModule(,int index),BOOL;
	declare GetInterfaceCount(),int;
	declare GetInterface(CTypeInfo info,int index),BOOL;
	declare GetDispatchCount(),int;
	declare GetDispatch(CTypeInfo info,int index),BOOL;
	declare GetCoclassCount(),int;
//	declare GetCoclass(,int index),BOOL;
	declare GetAliasCount(),int;
//	declare GetAlias(,int index),BOOL;
	declare GetUnionCount(),int;
//	declare GetUnion(,int index),BOOL;

	ITypeLib *m_lib;      // Load
	UINT      m_tinfocnt; // Load
	TYPEKIND *m_kinds;    // Load
}
#define CTypeLib_argsize 3<<2


/*
#ifdef _ctypeinfo_exe_
//=====================================================================================
// test
//=====================================================================================
sub main()
{
	// set transcoding options
	STRINGIFY_NO_CPP         = TRUE; // convert all SDK types to aurora types
//	STRINGIFY_CONVERTENUMS   = TRUE; // convert enum names to int
//	STRINGIFY_CONVERTSTRUCTS = TRUE; // convert structure names to pointers
//	STRINGIFY_CONVERTALIASES = TRUE; // convert alias names to pointer or int...
	CoInitialize(NULL);
	main2();
	CoUninitialize();
	CoFreeUnusedLibraries();
print('a'-'A');
	readln();
	return;
}
sub main2()
{
	ITypeLib *ptypeLib = NULL;
	ITypeInfo *pTypeInfo = NULL;

	CTypeLib  lib;
	CTypeInfo info;     // typeinfo
	CTypeInfo derieved; // derieved interfaces
	CFuncDesc func;     // methods
	CVarDesc  var;      // properties

	lib.Load("mshtml.tlb");
	print("number of enums         : ", lib.GetEnumCount());
	print("number of structures    : ", lib.GetStructCount());
	print("number of modules       : ", lib.GetModuleCount());
	print("number of interfaces    : ", lib.GetInterfaceCount());
	print("number of dispinterfaces: ", lib.GetDispatchCount());
	print("number of classes       : ", lib.GetCoclassCount());
	print("number of aliases       : ", lib.GetAliasCount());
	print("number of unions        : ", lib.GetUnionCount());
	print("number of all           : ", lib.GetCount());
	lib.GetInterface(info, 5);
	lib.Free();                // optional, releases all resources


	info.SetSafeMode(TRUE);
	func.SetSafeMode(TRUE);
	var.SetSafeMode(TRUE);
	derieved.SetSafeMode(TRUE);

	string *name;
	string *type;
	int     methods;
#ifdef _0
	if (info.FindDefinition("OleDragModeSettings"))
	{
		string *pHeap = info.GetEnumDef("OleDragModeSettings");
		MessageBoxA(0,pHeap,"",0);
		// if safe mode is ON and the GetEnumDef has hailed, the pHeap variable will be pointed to
		// internal empty, static string. If you try to FreeHeap, it will throw exception
		info.SafeFreeHeap(&pHeap);
	}
#endif

	// print interface name
	name = info.GetName();
	print("interface: ", *name,);

	// print out all derieved interface names
	derieved.Attach(info);
	while (derieved.GetDerieved(derieved))
	{
		name = derieved.GetName();
		print(" : ", *name,);
	}
	derieved.Free(); // optional, releases all resources
	print();

	// number of methods
	methods = info.GetFuncCount();
	print("number of methods: ", methods);

	// documentation
	name = info.GetDocString();
	print("documentation: ", *name);

	// help file
	name = info.GetHelpFile();
	print("help file: ", *name);

	// print out all methods
	print();
	for (int m=0; m<methods; m++)
	{
		info.GetFuncDesc(m, func);
		name = func.GetName(TRUE);//,"Get","Set","PutRef"
		if (*name == "QueryInterface")
		{
			m+=2; goto continue; // skip 3 IUnknown methods
		}
		if (*name == "GetTypeInfoCount")
		{
			m+=3; goto continue; // skip 4 IDispatch methods
		}
		print(" - ", *name, "(",);

		int paramscnt = func.GetParamsCount();
		for (int a=0; a<paramscnt; a++)
		{
		//	name = func.GetParamName(a);
		//	type = func.GetParamtype(a);
		//	print(*type, " ", *name,);
			name = func.GetParamTypeAndName(a);
			print(*name,);
			if ((a+1)<paramscnt) print(",",);
		}
		type = func.GetRetvalType();

		if func.HasReturnValue()
			print("),", *type, ";")
		else
			print(");");
continue:
	}
	func.Free(); // optional, releases all resources

	int propcnt = info.GetVarCount();
	print("\nnumber of properties: ",propcnt);
//	if (propcnt > 20) propcnt = 20;
	for (m=0; m<propcnt; m++)
	{
		info.GetVarDesc(m, var);
		name = var.GetName();
		type = var.GetType();
		print(*type, " ",*name);
	}
}
#endif
*/
//=====================================================================================
// CSafePointer
//=====================================================================================

CSafePointer::CSafePointer()
{
	m_isSafe=FALSE;
}

CSafePointer::SetSafeMode(BOOL safe)
{
	m_isSafe=safe;
}

CSafePointer::GetSafePointer(string *pstr),string *
{
	if (m_isSafe && !pstr) pstr="";
	return pstr;
}

CSafePointer::SafeFreeHeap(void *ppVariable)
{
	if (ppVariable)
	{
		string *pheap = *(pointer)ppVariable;
		if (pheap && (pheap != &"")) FreeHeap(pheap);
		*(pointer)ppVariable = NULL;
	}
}

CSafePointer::ChooseValidPointer(string *str1,string *str2),string *
{
	string *ptr = str1;
	if (!ptr) ptr = str2;
	return GetSafePointer(ptr);
}

CSafePointer::SafeRelease(IUnknown *ppUnk)
{
	if (ppUnk)
	{
		IUnknown *unk = *(pointer)ppUnk;
		if (unk) unk->Release();
		*(pointer)ppUnk = NULL;
	}
}

//=====================================================================================
// CTypeInfo
//=====================================================================================

CTypeInfo::CTypeInfo()
{
	ZeroMemory(&m_pti, CTypeInfo_argsize);
}

CTypeInfo::_CTypeInfo()
{
	if (m_pti)
	{
		if (m_ptattr) m_pti->ReleaseTypeAttr(m_ptattr);
		SafeRelease(&m_pti);
	}
	SafeRelease(&m_finder);
	SafeRelease(&m_stdole);
	SafeRelease(&m_tlb);
	SafeFreeHeap(&m_pName);
	SafeFreeHeap(&m_pDocString);
	SafeFreeHeap(&m_pHelpFile);
	CTypeInfo();
}

CTypeInfo::GetName(MEMBERID memid),string*
{
	SafeFreeHeap(&m_pName);
	BSTR bstr = NULL;
	if (m_pti && !m_pti->GetDocumentation(memid, &bstr,NULL,NULL,NULL) && bstr)
	{
		m_pName = __w2s(bstr);
	}
	return GetSafePointer(m_pName);
}
CTypeInfo::Free() {_CTypeInfo();}

CTypeInfo::GetDocString(MEMBERID memid),string*
{
	SafeFreeHeap(&m_pDocString);
	BSTR bstr = NULL;
	if (m_pti && !m_pti->GetDocumentation(memid,NULL,&bstr,NULL,NULL) && bstr)
	{
		m_pDocString = __w2s(bstr);
	}
	return GetSafePointer(m_pDocString);
}

CTypeInfo::GetHelpFile(MEMBERID memid),string*
{
	SafeFreeHeap(&m_pHelpFile);
	BSTR bstr = NULL;
	if (m_pti && !m_pti->GetDocumentation(memid,NULL,NULL,NULL,&bstr) && bstr)
	{
		m_pHelpFile = __w2s(bstr);
	}
	return GetSafePointer(m_pHelpFile);
}

CTypeInfo::GetHelpContext(MEMBERID memid),int
{
	if (m_pti) m_pti->GetDocumentation(memid,NULL,NULL,&m_HelpContext,NULL);
	return m_HelpContext;
}

CTypeInfo::AttachTypeInfo(ITypeInfo *pti),BOOL
{
	Free();
	m_pti = pti;
	if (m_pti)
	{
		m_pti->AddRef();
		if (m_pti->GetTypeAttr(&m_ptattr)) m_ptattr = NULL;
	}
	return (m_ptattr!=NULL);
}

CTypeInfo::Attach(CTypeInfo info),BOOL
{
	return AttachTypeInfo(info.m_pti);
}

CTypeInfo::GetFuncCount(),int
{
	int count = 0;
	if (m_ptattr) count = m_ptattr->cFuncs;
	return count;
}

CTypeInfo::GetVarCount(),int
{
	int count = 0;
	if (m_ptattr) count = m_ptattr->cVars;
	return count;
}

CTypeInfo::GetVarDesc(int index,CVarDesc var),BOOL
{
	BOOL ok = FALSE;
	var.Free();
	if (m_pti && m_ptattr && (index >= 0) && (index < m_ptattr->cVars))
	{
		VARDESC *pvardesc = NULL;
		if (!m_pti->GetVarDesc(index, &pvardesc) && pvardesc)
		{
			var.m_pti = m_pti;
			var.m_vardesc = pvardesc;
			m_pti->AddRef();
			ok = TRUE;
		}
	}
}

CTypeInfo::GetDerieved(CTypeInfo info,int index),BOOL
{
	BOOL ok = FALSE;

	if (m_pti && m_ptattr && (m_ptattr->cImplTypes > 0))
	{
		HREFTYPE href = 0;
		if (!m_pti->GetRefTypeOfImplType(index, &href) && href)
		{
			ITypeInfo *ptiImpl = NULL;
			if (!m_pti->GetRefTypeInfo( href, &ptiImpl))
			{
				info.Free();
				ok = info.AttachTypeInfo(ptiImpl);
				SafeRelease(&ptiImpl);
			}
		}
	}
	return ok;
}


CTypeInfo::GetFuncDesc(int index,CFuncDesc func),BOOL
{
	FUNCDESC *funcdesc = NULL;
	func.Free();
	if (m_pti)
	{
		if (!m_pti->GetFuncDesc(index, &funcdesc) && funcdesc)
		{
			func.m_pti = m_pti;
			func.m_funcdesc = funcdesc;
			m_pti->AddRef();
			func.Init();
		}
	}
	return funcdesc;
}

CTypeInfo::FindDefinition(string *name),BOOL
{
	BOOL found = FALSE;
	wstring *pName = NULL;
	if (name) pName = __s2w(name);

	SafeRelease(&m_finder);

	// search first in current typelib
	if (!m_tlb)
	{
		int index;
		if (m_pti) m_pti->GetContainingTypeLib(&m_tlb, &index);
	}
	if (m_tlb && pName)
	{
		MEMBERID mid;
		int midcnt = 1;
		if (!m_tlb->FindName(pName, 0, &m_finder, &mid, &midcnt) && midcnt && m_finder)
		{
			found = TRUE;
		}
		else m_finder = NULL; // in case...
	}
	// if not found, search in stdole
	if (!found)
	{
		if (!m_stdole) LoadTypeLib(L"stdole2.tlb", &m_stdole);
		if (m_stdole && pName)
		{
			midcnt = 1;
			if (!m_stdole->FindName(pName, 0, &m_finder, &mid, &midcnt) && midcnt && m_finder)
			{
				found = TRUE;
			}
			else m_finder = NULL; // in case...
		}
	}
	if (pName) FreeHeap(pName);
	return found;
}

CTypeInfo::GetStructDef(string *StructName),string*
{
	string *pDefinition = NULL;
	if (FindDefinition(StructName))
	{
		//m_finder is the ITypeLib
		TYPEATTR *typeAttr = NULL;
		if (!m_finder->GetTypeAttr(&typeAttr) && typeAttr)
		{
			LPSTR *typearray = new(LPSTR, typeAttr->cVars);
			LPSTR *namearray  = new(LPSTR, typeAttr->cVars + 1);
			string *pHeapString;
			// calculate minimal memory size for enum definition
			//  1 - always terminated with zero
			// 12 - struct ?\n{\n
			//  5 - \t? ?;\n
			//  1 - }
			int HeapLen = 14;
			if (typearray && namearray)
			{
				// get struct name
				BSTR pCurName = NULL;
				if (!m_finder->GetDocumentation(MEMBERID_NIL, &pCurName, 0, 0, 0) && pCurName)
				{
					pHeapString = __w2s(pCurName);
					*namearray[0] = pHeapString;
					SysFreeString(pCurName);
					if (pHeapString) HeapLen += _astrlen(pHeapString);

					// get all variable names
					for(UINT curValue=0; curValue < typeAttr->cVars; curValue++)
					{
						VARDESC *pVarDesc = NULL;
						if (!m_finder->GetVarDesc(curValue, &pVarDesc) && pVarDesc)
						{
							// get member type
							if (pVarDesc->lpvarValue) // VARIANT*
							{
								*typearray[curValue] = pVarDesc->lpvarValue->intVal;
							}
							// get struct member name
							pCurName = NULL;
							if (!m_finder->GetDocumentation(pVarDesc->memid, &pCurName, 0, 0, 0) && pCurName)
							{
								pHeapString = __w2s(pCurName);
								*namearray[curValue+1] = pHeapString;
								SysFreeString(pCurName);
								if (pHeapString) HeapLen += (_astrlen(pHeapString) + 5); // <TAB>TYPE NAME;<NEWLINE>
							}
							m_finder->ReleaseVarDesc(pVarDesc);
						}
					}
					// we got atleast the enum name. Create the enum definition
					pDefinition = AllocHeap(HeapLen);
					if (pDefinition)
					{
						// sprintf returns the number of characters written, or -1 if an error occurred
						// we use seeking string pointer (pstrNext) to speedup
						string *pstrNext = pDefinition + 
							sprintf(pDefinition, "struct %s\n{\n", *namearray[0]);

						for(curValue=0; curValue < typeAttr->cVars; curValue++)
						{
							pHeapString = *namearray[curValue+1];
							if (pHeapString)
							{
								pstrNext += sprintf(pstrNext, "	%s %s;\n", *typearray[curValue], pHeapString);
							}
						}
						// finish the struct
						_astrcpy(pstrNext, "\n}");
					}
					// now free the heap strings from array
					for(curValue=1; curValue <= typeAttr->cVars; curValue++)
					{
						pHeapString = *namearray[curValue+1];
						if (pHeapString) FreeHeap(pHeapString);
					}
				}
			}
			// cleanup all
			if (typearray) delete typearray;
			if (namearray) delete namearray;
			m_finder->ReleaseTypeAttr(typeAttr);
		}
	}
	return GetSafePointer(pDefinition);
}

CTypeInfo::GetEnumDef(string *EnumName),string*
{
	string *pDefinition = NULL;

	if (FindDefinition(EnumName))
	{
		//m_finder is the ITypeLib
		TYPEATTR *typeAttr = NULL;
		if (!m_finder->GetTypeAttr(&typeAttr) && typeAttr)
		{
			// calculate memory size for all variables
			DWORD *valuearray = new(DWORD, typeAttr->cVars);
			LPSTR *namearray  = new(LPSTR, typeAttr->cVars + 1);
			string *pHeapString;
			// calculate minimal memory size for enum definition
			//  1 - always terminated with zero
			// 10 - enum ?\n{\n
			// 17 - \t? = 0xXXXXXXXX,\n    should be ((17 * cVars)-1) + sizeof strings [why -1? last enum ends without comma]
			//  1 - }
			int HeapLen = 12;

			if (valuearray && namearray)
			{
				// get enum name
				BSTR pCurName = NULL;
				if (!m_finder->GetDocumentation(MEMBERID_NIL, &pCurName, 0, 0, 0) && pCurName)
				{
					pHeapString = __w2s(pCurName);
					*namearray[0] = pHeapString;
					SysFreeString(pCurName);
					if (pHeapString) HeapLen += _astrlen(pHeapString);
					// get all variable names
					for(UINT curValue=0; curValue < typeAttr->cVars; curValue++)
					{
						VARDESC *pVarDesc = NULL;
						if (!m_finder->GetVarDesc(curValue, &pVarDesc) && pVarDesc)
						{
							// get enum value
							if (pVarDesc->lpvarValue) // VARIANT*
							{
								*valuearray[curValue] = pVarDesc->lpvarValue->intVal;
							}
							// get enum member name
							pCurName = NULL;
							if (!m_finder->GetDocumentation(pVarDesc->memid, &pCurName, 0, 0, 0) && pCurName)
							{
								pHeapString = __w2s(pCurName);
								*namearray[curValue+1] = pHeapString;
								SysFreeString(pCurName);
								if (pHeapString) HeapLen += (_astrlen(pHeapString) + 17); // <TAB>name = 0x12345678,<NEWLINE>
							}
							m_finder->ReleaseVarDesc(pVarDesc);
						}
					}
					// we got atleast the enum name. Create the enum definition
					pDefinition = AllocHeap(HeapLen);
					if (pDefinition)
					{
						// sprintf returns the number of characters written, or -1 if an error occurred
						// we use seeking string pointer (pstrNext) to speedup
						string *pstrNext = pDefinition + 
							sprintf(pDefinition, "enum %s\n{\n", *namearray[0]);

						for(curValue=0; curValue < typeAttr->cVars; curValue++)
						{
							pHeapString = *namearray[curValue+1];
							if (pHeapString)
							{
								pstrNext += sprintf(pstrNext, "	%s = 0x%.8X,\n", pHeapString, *valuearray[curValue]);
							}
						}
						// for last enum remove the comma
						pstrNext -= (2 + (*(byte)(pstrNext-3) == ','));
						// end the enum
						_astrcpy(pstrNext, "\n}");
					}
					// now free the heap strings from array
					for(curValue=1; curValue <= typeAttr->cVars; curValue++)
					{
						pHeapString = *namearray[curValue];
						if (pHeapString) FreeHeap(pHeapString);
					}
				}
			}
			// cleanup all
			if (valuearray) delete valuearray;
			if (namearray) delete namearray;
			m_finder->ReleaseTypeAttr(typeAttr);
		}
	}
	return GetSafePointer(pDefinition);
}

//=====================================================================================
// CFuncDesc
//=====================================================================================

CFuncDesc::CFuncDesc()
{
	ZeroMemory(&m_pti, CFuncDesc_argsize);
}

CFuncDesc::_CFuncDesc()
{
	if (m_pti)
	{
		if (m_funcdesc) m_pti->ReleaseFuncDesc(m_funcdesc);
		SafeRelease(&m_pti);
	}
	if (m_names)
	{
		for (x=0; x<m_namescount; x++)
		{
			string *p = *m_names[x];
			SafeFreeHeap(&p);
		}
	}
	SafeFreeHeap(&m_paramtype);
	SafeFreeHeap(&m_retvaltype);
	SafeFreeHeap(&m_nameprefixed);
	SafeFreeHeap(&m_paramtypename);
	CFuncDesc();
}
CFuncDesc::Free() {_CFuncDesc();}

CFuncDesc::Init()
{
	m_names = NULL;
	if (m_pti && m_funcdesc)
	{
		m_namescount = m_funcdesc->cParams + 1;
		BSTR *names = AllocHeap(m_namescount<<2);
		if (names)
		{
			int nCount;
			if (!m_pti->GetNames(m_funcdesc->memid, names, m_namescount, &nCount))
			{
				m_names = AllocHeap(m_namescount<<2);
				if (m_names)
				{
					for (int x=0; x<nCount; x++)
					{
						wstring *p = *names[x];
						if (p) {*m_names[x] = __w2s(p);}
					}
				}
				for (x=0; x<nCount; x++)
				{
					p = *names[x];
					if (p) SysFreeString(p);
				}
			}
			SafeFreeHeap(&names);
		}
	}
}

CFuncDesc::GetName(BOOL withprefix,string* get_,string* put_,string* putref_),string *
{
	string *name = NULL;
	if (m_names)
	{
		name = *m_names[0];
		if (m_funcdesc && withprefix)
		{
			string *prefix = NULL;
			if (m_funcdesc->invkind == INVOKE_PROPERTYGET) prefix = ChooseValidPointer(get_,"get_");
			if (m_funcdesc->invkind == INVOKE_PROPERTYPUT) prefix = ChooseValidPointer(put_, "put_");
			if (m_funcdesc->invkind == INVOKE_PROPERTYPUTREF) prefix = ChooseValidPointer(putref_,"putref_");
			if (prefix)
			{
				SafeFreeHeap(&m_nameprefixed);
				m_nameprefixed = __strappend(prefix, name);
				name = m_nameprefixed;
			}
		}
	}
	return GetSafePointer(name);
}

CFuncDesc::GetParamsCount(),int
{
	int count = 0;
	if (m_funcdesc) count = m_funcdesc->cParams;
	return count;
}

CFuncDesc::GetParamName(int index),string *
{
	string *name = NULL;
	if (m_funcdesc && (index>=0) && (index<m_funcdesc->cParams))
	{
		name = *m_names[index+1];
		if (!name) name = "rhs";
	}
	return GetSafePointer(name);
}

CFuncDesc::GetParamType(int index),string *
{
	SafeFreeHeap(&m_paramtype);
	TYPEDESC *tdesc = GetParamTypeEx(index);
	if (tdesc)
	{
		m_paramtype = __stringifyTypeDesc(tdesc, m_pti);
	}
	return GetSafePointer(m_paramtype);
}

CFuncDesc::GetParamTypeEx(int index),TYPEDESC *
{
	TYPEDESC *tdesc = NULL;
	if (m_pti && m_funcdesc && (index>=0) && (index<m_funcdesc->cParams))
	{
		tdesc = m_funcdesc->*(ELEMDESC)lprgelemdescParam[index].tdesc;
	}
	return tdesc;
}

CFuncDesc::HasReturnValue(),BOOL
{
	BOOL has = FALSE;
	if (m_pti && m_funcdesc) has = (m_funcdesc->elemdescFunc.tdesc.vt != VT_VOID);
	return has;
}

CFuncDesc::GetRetvalType(),string *
{
	SafeFreeHeap(&m_retvaltype);
	if (m_pti && m_funcdesc)
	{
		m_retvaltype = __stringifyTypeDesc(m_funcdesc->elemdescFunc.tdesc, m_pti);
	}
	return GetSafePointer(m_retvaltype);
}

CFuncDesc::GetParamTypeAndName(int index),string *
{
	BOOL safe = m_isSafe;
	m_isSafe = TRUE;
	SafeFreeHeap(&m_paramtypename);
	string *name = GetParamName(index);
	string *type = GetParamType(index);
	m_paramtypename = AllocHeap(_astrlen(type)+_astrlen(name)+2);
	if (m_paramtypename) sprintf(m_paramtypename, "%s %s", type, name);
	m_isSafe = safe;
	return GetSafePointer(m_paramtypename);
}

//=====================================================================================
// CVarDesc
//=====================================================================================

CVarDesc::CVarDesc()
{
	ZeroMemory(&m_pti, CVarDesc_argsize);
}

CVarDesc::_CVarDesc()
{
	if (m_pti)
	{
		if (m_vardesc) m_pti->ReleaseVarDesc(m_vardesc);
		SafeRelease(&m_pti);
	}
	SafeFreeHeap(&m_pName);
	SafeFreeHeap(&m_pType);
	CVarDesc();
}
CVarDesc::Free() {_CVarDesc();}

CVarDesc::GetName(),string*
{
	SafeFreeHeap(&m_pName);
	BSTR bstr = NULL;
	if (m_pti && m_vardesc && !m_pti->GetDocumentation(m_vardesc->memid, &bstr,NULL,NULL,NULL) && bstr)
	{
		m_pName = __w2s(bstr);
	}
	return GetSafePointer(m_pName);
}

CVarDesc::GetType(),string*
{
	SafeFreeHeap(&m_pType);
	if (m_pti && m_vardesc)
	{
		m_pType = __stringifyTypeDesc(m_vardesc->elemdescVar.tdesc, m_pti);
	}
	return GetSafePointer(m_pType);
}

//=====================================================================================
// CTypeLib
//=====================================================================================

CTypeLib::CTypeLib()
{
	ZeroMemory(&m_lib, CTypeLib_argsize);
}

CTypeLib::_CTypeLib()
{
	SafeRelease(&m_lib);
	SafeFreeHeap(&m_kinds);
	CTypeLib();
}

CTypeLib::Free()
{
	CTypeLib();
}


CTypeLib::Load(string *filename),BOOL
{
	BOOL loaded = FALSE;
	Free();
	if (filename && !LoadTypeLib(s2w(*filename), &m_lib))
	{
		loaded = TRUE;
		m_tinfocnt = m_lib->GetTypeInfoCount();
		if (m_tinfocnt)
		{
			m_kinds = AllocHeap(sizeof(TYPEKIND) * m_tinfocnt);
			if (m_kinds)
			{
				for (int index=0; index<m_tinfocnt; index++)
				{
					m_lib->GetTypeInfoType(index, &*m_kinds[index]);
				}
			}
		}
	}
	return loaded;
}

CTypeLib::GetCount(),int
{
	return m_tinfocnt;
}

CTypeLib::GetTypeInfo(CTypeInfo info,int index),BOOL
{
	BOOL ok = FALSE;
	info.Free();
	if (m_lib && (index>=0) && (index<m_tinfocnt))
	{
		ITypeInfo *pti = NULL;
		if (!m_lib->GetTypeInfo(index, &pti))
		{
			ok = info.AttachTypeInfo(pti);
			if (!ok) SafeRelease(&pti);
		}
	}
	return ok;
}

CTypeLib::GetTypeInfoOfGuid(CTypeInfo info,GUID *guid),BOOL
{
	BOOL ok = FALSE;
	info.Free();
	if (m_lib && guid)
	{
		ITypeInfo *pti = NULL;
		if (!m_lib->GetTypeInfoOfGuid(guid, &pti))
		{
			ok = info.AttachTypeInfo(pti);
			if (!ok) SafeRelease(&pti);
		}
	}
	return ok;
}

CTypeLib::GetKindCount(TYPEKIND tkind),int
{
	int count = 0;
	if (m_kinds)
	{
		for (int x=0; x<m_tinfocnt; x++)
		{
			if (*m_kinds[x] == tkind) count++;
		}
	}
	return count;
}

CTypeLib::GetKindIndex(TYPEKIND tkind,int index),int
{
	if (m_kinds)
	{
		for (int x=0; x<m_tinfocnt; x++)
		{
			if (*m_kinds[x] == tkind)
			{
				if (!index) return x;
				index--;
			}
		}
	}
	return -1;
}

CTypeLib::GetInterfaceCount(),int
{
	return GetKindCount(TKIND_INTERFACE);
}

CTypeLib::GetInterface(CTypeInfo info,int index),BOOL
{
	return GetTypeInfo(info, GetKindIndex(TKIND_INTERFACE, index));
}

CTypeLib::GetEnumCount(),int
{
	return GetKindCount(TKIND_ENUM);
}

CTypeLib::GetStructCount(),int
{
	return GetKindCount(TKIND_RECORD);
}

CTypeLib::GetModuleCount(),int
{
	return GetKindCount(TKIND_MODULE);
}

CTypeLib::GetDispatchCount(),int
{
	return GetKindCount(TKIND_DISPATCH);
}

CTypeLib::GetDispatch(CTypeInfo info,int index),BOOL
{
	return GetTypeInfo(info, GetKindIndex(TKIND_DISPATCH, index));
}

CTypeLib::GetCoclassCount(),int
{
	return GetKindCount(TKIND_COCLASS);
}

CTypeLib::GetAliasCount(),int
{
	return GetKindCount(TKIND_ALIAS);
}

CTypeLib::GetUnionCount(),int
{
	return GetKindCount(TKIND_UNION);
}
