%include "asm.inc"

global stringifyCustomType
global stringifyVarDesc
global stringifyTypeDesc
global GetVariantMemberName
global $STRINGIFY_NO_CPP
global $STRINGIFY_CONVERTENUMS    ; if TRUE all enums are converted to "int"
global $STRINGIFY_CONVERTSTRUCTS  ; if TRUE all structs are converted to "int"
global $STRINGIFY_CONVERTALIASES
global GetTypeFlagsStr
global GetVartypeName

%define IUnknown_QueryInterface (4*0)
%define IUnknown_AddRef (4*1)
%define IUnknown_Release (4*2)

%define ITypeInfo_GetTypeAttr (4*3)
%define ITypeInfo_GetTypeComp (4*4)
%define ITypeInfo_GetFuncDesc (4*5)
%define ITypeInfo_GetVarDesc (4*6)
%define ITypeInfo_GetNames (4*7)
%define ITypeInfo_GetRefTypeOfImplType (4*8)
%define ITypeInfo_GetImplTypeFlags (4*9)
%define ITypeInfo_GetIDsOfNames (4*10)
%define ITypeInfo_Invoke (4*11)
%define ITypeInfo_GetDocumentation (4*12)
%define ITypeInfo_GetDllEntry (4*13)
%define ITypeInfo_GetRefTypeInfo (4*14)
%define ITypeInfo_AddressOfMember (4*15)
%define ITypeInfo_CreateInstance (4*16)
%define ITypeInfo_GetMops (4*17)
%define ITypeInfo_GetContainingTypeLib (4*18)
%define ITypeInfo_ReleaseTypeAttr (4*19)
%define ITypeInfo_ReleaseFuncDesc (4*20)
%define ITypeInfo_ReleaseVarDesc (4*21)

struc TYPEDESC
.lptdesc  resd 0 ; TYPEDESC *
.lpadesc  resd 0;//ARRAYDESC
.hreftype resd 1 ; HREFTYPE
.vt       resw 2 ; VARTYPE
endstruc



struc SAFEARRAYBOUND
.cElements resd 1
.lLbound   resd 1
endstruc

struc ARRAYDESC
.tdescElem
.tdescElem.lptdesc  resd 0 ; TYPEDESC.TYPEDESC *
.tdescElem.lpadesc  resd 0 ; TYPEDESC.ARRAYDESC
.tdescElem.hreftype resd 1 ; TYPEDESC.HREFTYPE
.tdescElem.vt       resw 2 ; TYPEDESC.VARTYPE
.cDims              resw 2 ; USHORT
.rgbounds.cElements resd 1 ; SAFEARRAYBOUND
.rgbounds.lLbound   resd 1 ; SAFEARRAYBOUND
endstruc

struc VARIANT
.vt  resw 4
.val resd 2
endstruc

struc IDLDESC
.dwReserved resd 1 ; ULONG_PTR
.wIDLFlags  resw 2 ; USHORT
endstruc

struc PARAMDESCEX
.cBytes resd 2 ; ULONG
.varDefaultValue.vt  resw 4 ; VARIANT
.varDefaultValue.val resd 2 ; VARIANT
endstruc

struc PARAMDESC
.pparamdescex resd 1; PARAMDESCEX*
.wParamFlags  resw 2 ;USHORT
endstruc

struc ELEMDESC
.tdesc.lptdesc  resd 0 ; TYPEDESC.TYPEDESC *
.tdesc.lpadesc  resd 0 ; TYPEDESC.ARRAYDESC
.tdesc.hreftype resd 1 ; TYPEDESC.HREFTYPE
.tdesc.vt       resw 2 ; TYPEDESC.VARTYPE
.idldesc.dwReserved     resd 0 ; IDLDESC.ULONG_PTR
.paramdesc.pparamdescex resd 1 ; PARAMDESC.PARAMDESCEX*
.idldesc.wIDLFlags      resw 0 ; IDLDESC.USHORT
.paramdesc.wParamFlags  resw 2 ; PARAMDESC.USHORT
endstruc

struc VARDESC
.memid       resd 1 ; MEMBERID
.lpstrSchema resd 1 ; LPOLESTR*

.oInst       resd 0 ; ULONG
.lpvarValue  resd 1 ; VARIANT *

.elemdescVar.tdesc 
.elemdescVar.tdesc.lptdesc  resd 0 ; ELEMDESC.TYPEDESC.TYPEDESC *
.elemdescVar.tdesc.lpadesc  resd 0 ; ELEMDESC.TYPEDESC.ARRAYDESC
.elemdescVar.tdesc.hreftype resd 1 ; ELEMDESC.TYPEDESC.HREFTYPE
.elemdescVar.tdesc.vt       resw 2 ; ELEMDESC.TYPEDESC.VARTYPE
.elemdescVar.idldesc.dwReserved     resd 0 ; ELEMDESC.IDLDESC.ULONG_PTR
.elemdescVar.paramdesc.pparamdescex resd 1 ; ELEMDESC.PARAMDESC.PARAMDESCEX*
.elemdescVar.idldesc.wIDLFlags      resw 0 ; ELEMDESC.IDLDESC.USHORT
.elemdescVar.paramdesc.wParamFlags  resw 2 ; ELEMDESC.PARAMDESC.USHORT

.wVarFlags resw 1
.varkind resd 1; VARKIND
endstruc


struc DECIMAL
.wReserved resw 1
.signscale resw 0 ; union 1
.scale     resb 1 ; union 1
.sign      resb 1 ; union 1
.Hi32      resd 1
.Lo64      resd 0 ; union 2
.Lo32      resd 1 ; union 2
.Mid32     resd 1 ; union 2
endstruc

struc TYPEATTR
.guid resd 4
.lcid resd 1
.dwReserved resd 1
.memidConstructor resd 1
.memidDestructor resd 1
.lpstrSchema resd 1
.cbSizeInstance resd 1
.typekind resd 1
.cFuncs resw 1
.cVars resw 1
.cImplTypes resw 1
.cbSizeVft resw 1
.cbAlignment resw 1
.wTypeFlags resw 1
.wMajorVerNum resw 1
.wMinorVerNum resw 1
.tdescAlias resb sizeof(TYPEDESC)
.idldescType resb sizeof(IDLDESC)
endstruc

%define VT_EMPTY	  0
%define VT_NULL	  1
%define VT_BOOL	  11
%define VT_I1	  16
%define VT_I2	  2
%define VT_I4	  3
%define VT_I8	  20
%define VT_INT	  22
%define VT_INT_PTR	  37
%define VT_UI1	  17
%define VT_UI2	  18
%define VT_UI4	  19
%define VT_UI8	  21
%define VT_UINT	  23
%define VT_UINT_PTR	  38
%define VT_R4	  4
%define VT_R8	  5
%define VT_CY	  6
%define VT_DATE	  7
%define VT_BSTR	  8
%define VT_DISPATCH	  9
%define VT_ERROR	  10
%define VT_VARIANT	  12
%define VT_UNKNOWN	  13
%define VT_DECIMAL	  14
%define VT_VOID	  24
%define VT_HRESULT	  25
%define VT_PTR	  26
%define VT_SAFEARRAY	  27
%define VT_CARRAY	  28
%define VT_USERDEFINED	  29
%define VT_LPSTR	  30
%define VT_LPWSTR	  31
%define VT_RECORD	  36
%define VT_FILETIME	  64
%define VT_BLOB	  65
%define VT_STREAM	  66
%define VT_STORAGE	  67
%define VT_STREAMED_OBJECT	  68
%define VT_STORED_OBJECT	  69
%define VT_BLOB_OBJECT	  70
%define VT_CF	  71
%define VT_CLSID	  72
%define VT_VERSIONED_STREAM	  73
%define VT_BSTR_BLOB	  0xfff
%define VT_VECTOR	  0x1000
%define VT_ARRAY	  0x2000
%define VT_BYREF	  0x4000
%define VT_RESERVED	  0x8000
%define VT_ILLEGAL	  0xffff
%define VT_ILLEGALMASKED	  0xfff
%define VT_TYPEMASK	  0xfff

%define VAR_PERINSTANCE 0
%define VAR_STATIC 1
%define VAR_CONST 2
%define VAR_DISPATCH  3

%define TKIND_ENUM 0
%define TKIND_RECORD 1
%define TKIND_MODULE 2
%define TKIND_INTERFACE 3
%define TKIND_DISPATCH 4
%define TKIND_COCLASS 5
%define TKIND_ALIAS 6
%define TKIND_UNION 7
;--------------------------------------------------------------------------------
; types

%define VARTYPE word
%define VARKIND dword




;--------------------------------------------------------------------------------
stringifyCustomType: ;HREFTYPE refType, ITypeInfo* pti),string
	push    ebp
	mov     ebp,esp
	push    esi,edi,ebx
	%define pCustTypeInfo esi
	%define bstrType      edi
	%define refType [ebp+8]
	%define pti     [ebp+12]

	push     eax
	mov      esi,pti
	coinvoke esi,ITypeInfo_GetRefTypeInfo, refType, esp   ; pTypeInfo->GetRefTypeInfo(refType, &pCustTypeInfo);
	pop      pCustTypeInfo
	and      eax,eax
	jz      .1
	invoke   _dupstr, $szError1
	jmp     .q
.1:
	// pCustTypeInfo = ITypeInfo
	// use only standard types?
	mov      eax,[$STRINGIFY_NO_CPP]
	and      eax,eax
	jz      near .getdoc
	// yes
	push     eax
	coinvoke pCustTypeInfo,ITypeInfo_GetTypeAttr,esp
	pop      ebx
	assume   ebx,TYPEATTR
	and      eax,eax
	jnz      near .getdoc   ; if no TYPEATTR - do default
	mov      edx, TYPEATTR(typekind) ; save it

	;----------------------------------------- TKIND_ENUM - enum
	mov      eax,$szInt
	cmp      dx,TKIND_ENUM ; int
	jne     .a
	mov      ecx,[$STRINGIFY_CONVERTENUMS]
	and      ecx,ecx
	jnz     .dup
.abort:
	coinvoke pCustTypeInfo,ITypeInfo_ReleaseTypeAttr,ebx
	jmp     .getdoc
.a:
	;----------------------------------------- TKIND_RECORD - struct
	mov      eax,$szPointer
	cmp      dx,TKIND_RECORD ; pointer
	jne     .b
	mov      ecx,[$STRINGIFY_CONVERTSTRUCTS]
	and      ecx,ecx
	jnz     .dup
	jz      .abort

.b:
	;----------------------------------------- TKIND_INTERFACE
	cmp      dx,TKIND_INTERFACE ; pointer
	je      .dup
	;----------------------------------------- TKIND_DISPATCH
	cmp      dx,TKIND_DISPATCH ; pointer
	je      .dup
	;----------------------------------------- TKIND_COCLASS
	cmp      dx,TKIND_COCLASS ; pointer
	je      .dup
	;----------------------------------------- TKIND_ALIAS - if STRINGIFY_CONVERTALIASES is set
	cmp      dx,TKIND_ALIAS
	jne     .rta                               ; error ! (nomore)
	mov      ecx,[$STRINGIFY_CONVERTALIASES]
	and      ecx,ecx
	jz      .abort
	call     stringifyTypeDesc, offset TYPEATTR(tdescAlias), pCustTypeInfo
;	jmp     .rta
	;----------------------------------------- TKIND_MODULE unsupported
;	cmp      bx,TKIND_MODULE ; unsupported, return "pointer"
;	je      .dup
	;----------------------------------------- TKIND_UNION unsupported
;	cmp      bx,TKIND_UNION ; unsupported, return "pointer"
;	je      .dup
	;----------------------------------------- delete TYPEATTR and return initialized eax (heap)
.rta
	push     eax
	coinvoke pCustTypeInfo,ITypeInfo_ReleaseTypeAttr,ebx
	pop      eax
	jmp     .q
	;----------------------------------------- duplicate string in eax, delete TYPEATTR and return
.dup:
	invoke   _dupstr,eax
	jmp     .rta

.getdoc:
	push     eax
	xor      eax,eax
	mov      edx,esp
	coinvoke pCustTypeInfo,ITypeInfo_GetDocumentation, -1, edx, eax, eax, eax
	pop      bstrType
	mov      ebx,eax
	coinvoke pCustTypeInfo,IUnknown_Release
	and      ebx,ebx
	jz      .2
	invoke   _dupstr, $szError2
	jmp     .q
.2:
	invoke   w2s,bstrType
	invoke   SysFreeString, bstrType,eax
	pop      eax
.q:
	pop     ebx,edi,esi
	leave
	ret     8

;--------------------------------------------------------------------------------
align 4

stringifyVarDesc: ; (VARDESC* varDesc, ITypeInfo* pTypeInfo),string
	enter    sizeof(VARIANT),0
	push     esi,edi,ebx

	%define  varDesc   esi
	%define  oss       edi
	%define  pTypeInfo ebx

	mov      varDesc,[ebp+8]
	mov      pTypeInfo,[ebp+12]
	assume   esi,VARDESC

	invoke   AllocHeap,256
	mov      oss,eax

	cmp      VARKIND VARDESC(varkind), VAR_CONST
	jne     .0
	invoke   _astrcpy, oss, $szConst
.0:
	call     stringifyTypeDesc, offset VARDESC(elemdescVar.tdesc), pTypeInfo
	invoke   _astrcat, oss, eax, eax
	invoke   FreeHeap

;	BSTR *bstrName;
	xor      eax,eax
	push     eax     ; bstrName
	mov      edx,esp ; &bstrName
	coinvoke pTypeInfo, ITypeInfo_GetDocumentation, VARDESC(memid), edx, eax, eax, eax
	and      eax,eax
	jz      .1
	pop      edx   ; bstrName
	invoke  _astrcpy, oss, $szError3
	jmp     .q
.1:
	invoke   _astrcat, oss, $szSpace
	; 2 * bstrName on stack
	invoke   w2s,[esp]
	; bstrName on stack
	push     eax                  ; FreeHeap
	invoke   _astrcat, oss, eax
	invoke   FreeHeap
	invoke   SysFreeString
;	if(varDesc->varkind != VAR_CONST) return oss;
	cmp      VARKIND VARDESC(varkind), VAR_CONST
	jne     .q
	invoke   _astrcat, oss, $szEqual

	mov      VARTYPE [ebp-sizeof(VARIANT)+VARIANT.vt],VT_EMPTY
	invoke   VariantChangeType, offset [ebp-sizeof(VARIANT)], VARDESC(lpvarValue), 0, VT_BSTR
	and      eax,eax
	jz      .2
	invoke   _astrcat, oss, $szError4
	jmp     .q
.2:
	mov      eax,[ebp-sizeof(VARIANT)+VARIANT.val]
	push     eax                     ; SysFreeString
	invoke   w2s,eax
	push     eax                     ; FreeHeap
	invoke   _astrcat, oss, eax
	invoke   FreeHeap
	invoke   SysFreeString
.q:
	mov      eax,oss

	pop      ebx,edi,esi
	leave
	ret      8

;--------------------------------------------------------------------------------
align 4

stringifyTypeDesc: ; (TYPEDESC* typeDesc, ITypeInfo* pTypeInfo),string
	push   ebp
	mov    ebp,esp
	push     esi,edi,ebx

	%define typeDesc esi
	mov     typeDesc,[ebp+8]
	assume  esi,TYPEDESC
;	g_array[0] = 0;

	%define pTypeInfo edi
	mov     pTypeInfo,[ebp+12]

	%define oss ebx

	mov   cx,TYPEDESC(vt)

;	dstring x[64];
	cmp     cx,VT_PTR
	jne    .0
	invoke  AllocHeap,256
	mov     oss,eax

	call    stringifyTypeDesc, TYPEDESC(lptdesc),pTypeInfo
	push    eax
	cdecl   sprintf, oss, $szFmt1, eax
	invoke  FreeHeap
	mov     eax,oss
	jmp    .q

.0:
	cmp     cx,VT_SAFEARRAY
	jne    .1
	invoke  AllocHeap,256
	mov     oss,eax
	call    stringifyTypeDesc, TYPEDESC(lptdesc), pTypeInfo
	push    eax
	cdecl   sprintf, oss, $szFmt2, eax
	invoke  FreeHeap
	mov     eax,oss
	jmp    .q

.1:
	cmp     cx,VT_CARRAY
	jne    .2
	invoke  AllocHeap,256
	mov     oss,eax

	call    stringifyTypeDesc, TYPEDESC(lpadesc), pTypeInfo
	push    eax
	invoke  _astrcpy, oss,eax
	invoke  FreeHeap
%if 0
		for(int d=0; d<typeDesc->lpadesc->cDims; d++) {
			if (!d) oss += $szBrace
			oss += str$(typeDesc->lpadesc->rgbounds[d].cElements);
			if ((d+1) < typeDesc->lpadesc->cDims) oss+=$szComa;
//			sprintf(x, "[%d...%d]", typeDesc->lpadesc->rgbounds[d].lLbound, typeDesc->lpadesc->rgbounds[d].cElements + typeDesc->lpadesc->rgbounds[d].lLbound - 1);
//			strcat(oss, x);
		}
		if d oss += "]";
%endif
	mov     eax,oss
	jmp    .q
.2:

	cmp     cx,VT_USERDEFINED
	jne    .3
	call    stringifyCustomType, TYPEDESC(hreftype), pTypeInfo
	jmp    .q

.3:
	mov     esi,$szError5
	cmp     cx,15 ; invalid: vt==15
	je     .copy
	cmp     cx,32 ; max:     vt>32
	ja     .copy
	cmp     cx,30 ; 26-30 invalid
	jae    .find
	cmp     cx,26
	jae    .copy

.find:
	mov     esi,$szVTypes ; cx = string index
	cmp     byte[$STRINGIFY_NO_CPP],0
	jz     .no_c
	mov     esi,$szVTypes2
.no_c:
	and     cx,cx
	jz     .copy
	.L:
	lodsb
	and     al,al
	jnz    .L
	dec     cx
	jnz    .L

.copy:
	invoke  _dupstr,esi
	jmp    .q

.q:

	pop      ebx,edi,esi,ebp
	ret      8


;--------------------------------------------------------------------------------
align 4
$szError1: db "/*error! (GetRefTypeInfo)*/int",0
align 4
$szError2: db "/*error! (GetDocumentation)*/int",0
align 4
$szError3: db "/*error! (GetDocumentation)*/x",0
align 4
$szError4: db "/*error! (VariantChangeType failed)*/",0
align 4
$szError5: db "BIG ERROR!",0
align 4
$szSpace:  dd " "
$szEqual:  dd " = "
$szFmt1:   dd "%s*"
$szFmt2:   dd "SAFEARRAY/*%s*/"
$szBrace:  dd "["
$szComa:   dd ","
$szConst   dd "const "
;--------------------------------------------------------------------------------

$szVTypes:
db "empty",0,"null",0,"short",0,"long",0,"float",0,"double",0,"CY",0,"DATE",0,"BSTR",0,"IDispatch*",0
db "SCODE",0,"VARIANT_BOOL",0,"VARIANT",0,"IUnknown*",0,"DECIMAL",0,"",0,"char",0,"BYTE",0,"USHORT",0,"ULONG",0
db "int64",0,"unsigned int64",0
$szInt: db "int",0,"UINT",0,"void",0,"HRESULT",0,"",0,"",0,"",0,"",0,"LPSTR",0,"LPWSTR",0

$szVTypes2:
db "empty",0,"null",0,"word",0,"int",0,"float",0,"double",0,"CY",0,"DATE",0,"wstring*",0,"pointer",0
db "SCODE",0,"BOOL",0,"VARIANT",0,"pointer",0,"DECIMAL",0,"",0,"byte",0,"unsigned byte",0,"unsigned word",0,"unsigned int",0
db "int64",0,"unsigned int64",0,"int",0,"unsigned int",0,"void",0,"int",0,"",0,"",0,"",0,"",0,"string*",0,"wstring*",0

align 4
$szPointer: db "pointer",0
///////////////////////////////////////////////////
// table to convert VARTYPE to variant member


align 4
GetVariantMemberName ; vt
	mov  dx,[esp+4]
	xchg esi,[esp+4]
	mov  esi,$macro1_table
.do:
	lodsw
	cmp  ax,-1
	je  .q     ; eof
	cmp  ax,dx
	je  .q     ; found
.skip:
	lodsb
	and  al,al
	jnz  .skip
	; align esi to next word
	mov  eax,esi
	and  eax,1
	add  esi,eax
	jmp .do
	
.q:
	mov  eax,esi
	xchg esi,[esp+4]
	ret  4




%macro macro1 2
	dw %1
	db %2,0
	align 2
%endm

align 4
$macro1_table:
macro1 VT_I8,"llval"
macro1 VT_I4,"lVal"
macro1 VT_UI1,"bVal"
macro1 VT_I2,"iVal"
macro1 VT_R4,"fltVal"
macro1 VT_R8,"dblVal"
macro1 VT_BOOL,"boolVal"
macro1 VT_ERROR,"scode"
macro1 VT_CY,"cyVal"
macro1 VT_DATE,"date"
macro1 VT_BSTR,"bstrVal"
macro1 VT_UNKNOWN,"punkVal"
macro1 VT_DISPATCH,"pdispVal"
macro1 VT_BYREF|VT_UI1,"pbVal"
macro1 VT_BYREF|VT_I2,"piVal"
macro1 VT_BYREF|VT_I4,"plVal"
macro1 VT_BYREF|VT_I8,"pllVal"
macro1 VT_BYREF|VT_R4,"pfltVal"
macro1 VT_BYREF|VT_R8,"pdblVal"
macro1 VT_BYREF|VT_BOOL,"pboolVal"
macro1 VT_BYREF|VT_ERROR,"pscode"
macro1 VT_BYREF|VT_CY,"pcyVal"
macro1 VT_BYREF|VT_DATE,"pdate"
macro1 VT_BYREF|VT_BSTR,"pbstrVal"
macro1 VT_BYREF|VT_UNKNOWN,"ppunkVal"
macro1 VT_BYREF|VT_DISPATCH,"ppdispVal"
macro1 VT_BYREF|VT_VARIANT,"pvarVal"
macro1 VT_VARIANT,"pvarVal"				; custom !
macro1 VT_I1,"cVal"
macro1 VT_UI2,"uiVal"
macro1 VT_UI4,"ulVal"
macro1 VT_UI8,"ullVal"
macro1 VT_INT,"intVal"
macro1 VT_UINT,"uintVal"
macro1 VT_BYREF|VT_DECIMAL,"pdecVal"
macro1 VT_BYREF|VT_I1,"pcVal"
macro1 VT_BYREF|VT_UI2,"puiVal"
macro1 VT_BYREF|VT_UI4,"pulVal"
macro1 VT_BYREF|VT_UI8,"pullVal"
macro1 VT_BYREF|VT_INT,"pintVal"
macro1 VT_BYREF|VT_UINT,"puintVal"
dw -1
db "punkVal /*GetVariantMemberName*/",0
;"bool"
;macro1 VT_ARRAY|*,"parray"
;"pbool"
;macro1 VT_ARRAY|*,"pparray"
;"byref"GenericByRef,

;--------------------------------------------------------------------------------
align 4
GetVartypeName: ; vt
	invoke AllocHeap, 32
	mov  dx,[esp+4]
	xchg esi,[esp+4]
	mov  esi,$vartypeNames
	push ebx               ; save ebx
	push eax               ; save heap
	mov  ebx,eax ; heap
	test dx,VT_VECTOR
	jz .a1
	mov  dword[ebx],"VT_V"
	mov  dword[ebx+4],"ECTO"
	mov   word[ebx+8],"R|"
	add  ebx,10
.a1:
	test dx,VT_ARRAY
	jz .a2
	mov  dword[ebx],"VT_A"
	mov  dword[ebx+4],"RRAY"
	mov   byte[ebx+8],"|"
	add  ebx,9
.a2:
	test dx,VT_BYREF
	jz .a3
	mov  dword[ebx],"VT_B"
	mov  dword[ebx+4],"YREF"
	mov   byte[ebx+8],"|"
	add  ebx,9
.a3:
	and  dx,VT_TYPEMASK

.do:
	lodsw
	cmp  ax,-1
	je  .q     ; eof
	cmp  ax,dx
	je  .q     ; found
.skip:
	lodsb
	and  al,al
	jnz  .skip
	; align esi to next word
	mov  eax,esi
	and  eax,1
	add  esi,eax
	jmp .do
	
.q:
	mov  word[ebx],"VT"
	mov  word[ebx+2],"_"
	add  ebx,3
.q1
	lodsb
	mov  [ebx],al ; append NULL
	inc  ebx
	and  al,al
	jnz .q1
	cmp  byte[ebx-2],"|"
	jne .q2
	mov  byte[ebx-2],"|"
.q2:
	pop  eax
	pop  ebx
	xchg esi,[esp+4]
	ret  4

$vartypeNames:
macro1 VT_I1,"I1"
macro1 VT_I2,"I2"
macro1 VT_I4,"I4"
macro1 VT_I8,"I8"
macro1 VT_UI1,"UI1"
macro1 VT_UI2,"UI2"
macro1 VT_UI4,"UI4"
macro1 VT_UI8,"UI8"
macro1 VT_INT,"INT"
macro1 VT_UINT,"UINT"
macro1 VT_R4,"R4"
macro1 VT_R8,"R8"
macro1 VT_BOOL,"BOOL"
macro1 VT_ERROR,"ERROR"
macro1 VT_CY,"CY"
macro1 VT_DATE,"DATE"
macro1 VT_BSTR,"BSTR"
macro1 VT_UNKNOWN,"UNKNOWN"
macro1 VT_DISPATCH,"DISPATCH"
macro1 VT_VARIANT,"VARIANT"
macro1 VT_DECIMAL,"DECIMAL"
macro1 VT_EMPTY,"EMPTY"
macro1 VT_NULL,"NULL"
macro1 VT_INT_PTR,"INT_PTR"
macro1 VT_UINT_PTR,"UINT_PTR"
macro1 VT_VOID,"VOID"
macro1 VT_SAFEARRAY,"SAFEARRAY"
macro1 VT_CARRAY,"CARRAY"
macro1 VT_USERDEFINED,"USERDEFINED"
macro1 VT_LPSTR,"LPSTR"
macro1 VT_LPWSTR,"LPWSTR"
macro1 VT_RECORD,"RECORD"
macro1 VT_FILETIME,"FILETIME"
macro1 VT_BLOB,"BLOB"
macro1 VT_STREAM,"STREAM"
macro1 VT_STORAGE,"STORAGE"
macro1 VT_STREAMED_OBJECT,"STREAMED_OBJECT"
macro1 VT_STORED_OBJECT,"STORED_OBJECT"
macro1 VT_BLOB_OBJECT,"BLOB_OBJECT"
macro1 VT_CF,"CF"
macro1 VT_CLSID,"CLSID"
macro1 VT_VERSIONED_STREAM,"VERSIONED_STREAM"
macro1 VT_BSTR_BLOB,"BSTR_BLOB"
macro1 VT_PTR,"PTR"
dw -1,0


segment .bss
$STRINGIFY_NO_CPP         resd 1
$STRINGIFY_CONVERTENUMS   resd 1
$STRINGIFY_CONVERTSTRUCTS resd 1
$STRINGIFY_CONVERTALIASES resd 1
segment .text


;--------------------------------------------------------------------------------

%define TYPEFLAG_FAPPOBJECT		 0x1
%define TYPEFLAG_FCANCREATE		 0x2
%define TYPEFLAG_FLICENSED		 0x4
%define TYPEFLAG_FPREDECLID		 0x8
%define TYPEFLAG_FHIDDEN		 0x10
%define TYPEFLAG_FCONTROL		 0x20
%define TYPEFLAG_FDUAL	    	 0x40
%define TYPEFLAG_FNONEXTENSIBLE	 0x80
%define TYPEFLAG_FOLEAUTOMATION	 0x100
%define TYPEFLAG_FRESTRICTED	 0x200
%define TYPEFLAG_FAGGREGATABLE	 0x400
%define TYPEFLAG_FREPLACEABLE	 0x800
%define TYPEFLAG_FDISPATCHABLE	 0x1000
%define TYPEFLAG_FREVERSEBIND	 0x2000
%define TYPEFLAG_FPROXY			 0x4000
align 4

$gtfs:
	db "[proxy][reversebind][dispatchable][replaceable][aggregatable][restricted][oleautomation]"
	db "[nonextensible][dual][control][hidden][predeclid][licensed][cancreate][appobject]"


align 4

GetTypeFlagsStr:
	push   esi,edi
	invoke AllocHeap,170
	mov    edi,eax
	push   eax
	mov    dx,[esp+8]
	mov    esi,$gtfs
	add    dx,dx
	jz    .q
.next:
	add    dx,dx
	jc    .append
	jz    .q
.skip
	lodsb
	cmp    al,']'
	jne   .skip
	jmp   .next
.append:
	lodsb
	mov    [edi],al
	inc    edi
	cmp    al,']'
	jne   .append
	jmp   .next
.q:
	mov    byte[edi],0
	pop    eax
	pop    edi,esi
	ret    4

